#zkmSocket module, zkm package

from zkm.zkmTrace import writeTrace, writeError

import socket

class ZkmSocket:
	def __init__(self, command=None, serverName=None, port=None):
		self.command = command
		self.serverName = serverName
		self.port = port
		return

	def tryConnect(self):
		try:
			self.clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		except:
			result = 0
		else:
			for i in range(0, 3):
				try:
					self.clientsock.connect(self.serverName, self.port)
				except Exception, data:
					result = 0
					writeError("ZkmSocket tryConnect() exception: " + `data`, command=self.command)
				else:
					result = 1
					break

		return result

	def sendCommandNoResponse(self):
		try:
			if self.tryConnect():
				self.clientsock.send(self.command.serialize())
				self.clientsock.close()
		except Exception, data:
			result = 0
			writeError("ZkmSocket sendCommandNoResponse() exception: " + `data`, command=self.command)
			try:
				self.clientsock.close()
			except:
				pass
		else:
			result = 1

		return result

	def sendCommandGetResponse(self):
		try:
			if self.tryConnect():
				self.clientsock.send(self.command.serialize())
				response = self.clientsock.recv(204800)
				self.clientsock.close()
		except Exception, data:
			fullResponse = (0, None)
			writeError("ZkmSocket sendCommandGetResponse() exception: " + `data`, command=self.command)
			try:
				self.clientsock.close()
			except:
				pass
		else:
			fullResponse = (1, response)

		return fullResponse


def cleanupSocket(sock):
	try:
		sock.close()
	except:
		pass
	return

